﻿package {	
	// IMPORTS
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	import flash.events.Event;
	import flash.geom.Rectangle;
	import fl.motion.Color;

	//
	public class Particles1 extends Sprite{
		//
		var rect:Rectangle;
		//
		private var bmpData:BitmapData;
		private var filterObj:BlurFilter = new BlurFilter(2,2,1);
		private var particuleCollection:Array=[];
		private var couleursCollection:Array=[0xffffffff,0xffffffff];
		public function Particles1(){
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void{
			bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			addChild(new Bitmap(bmpData)) as Bitmap;
			//rect = new Rectangle(0, 0,stage.stageWidth,stage.stageHeight);
			addEventListener(Event.ENTER_FRAME,boucle);
		}
		private function boucle(e:Event):void{
			//
			for(var i:int=0;i<4;i++){
				var angle:int=Math.round(Math.random()*360);
				var vitesse:Number = Math.random()*5;
				//
				var dist:Number = Math.random()*10;
				//
				creationDeParticules(Math.cos(angle/180*Math.PI)*Math.random()*vitesse,Math.sin(angle/180*Math.PI)*Math.random()*vitesse,couleursCollection[Math.round(Math.random())],mouseX+Math.cos(angle)*dist,mouseY+Math.sin(angle)*dist);
			}
			var o:int = particuleCollection.length;
			bmpData.lock();
			while(o--) {
				var p:Object = particuleCollection[o];
				p.x+=p.vx;
				p.y+=p.vy;
				//p.vx*=.95;
				//p.vy*=.95;
				p.life-=1;
				//var rounded_alphap:Number = Math.round(p.alphap);
				//var couleur:uint = int("0x"+rounded_alphap+"ffffff");
				p.vy+=0.2;
				bmpData.setPixel32(p.x,p.y,p.c);
				//REBONDS
				if(p.y>stage.stageHeight) {
					p.vy*=-0.75;
				}
				if(p.x>stage.stageWidth || p.x<0) {
					p.vx*=-0.75;
				}
				if (p.life <=0){particuleCollection.splice(o,1);}
			}
			bmpData.unlock();
			//bmpData.fillRect(rect,0x000000);
			bmpData.applyFilter(bmpData,bmpData.rect,new Point(0, 0),filterObj);
		}
		private function creationDeParticules(vitesseX:Number, vitesseY:Number, couleur:uint, positionX:Number=0, positionY:Number=0):void {
			var particule:Object = {};
			particule.x = positionX;
			particule.y = positionY;
			particule.vx = vitesseX;
			particule.vy = vitesseY;
			particule.c = couleur;
			particuleCollection.push(particule);
			particule.life = Math.random()*100+900;
		}
	}
}